#!/usr/bin/env python

from gtk import *
import _gtk
import os
import os.path
import time
import string
import signal
import sys
no_fcntl=0
try: import fcntl
except:
	no_fcntl=1
	print "fcntl not found, disabling irobex"
#import FCNTL

ConfigFileName="~/.fillorc"
Params=["irobex","show dotfiles","show dotdirs","show dirs","show dirtree"]


def spawn(path,params,caller=0):
	#print "spawn(",path,",",params,")"
	#return 0
	if os.access(path,os.F_OK):
		# ignore sigchild so we do not get zombies
        	signal.signal(signal.SIGCHLD, signal.SIG_IGN)
		if caller:
			stdout_r,stdout_w=os.pipe()
			stdin_r,stdin_w=os.pipe()
		a=os.fork();
		if (a==0):
			#print "son, executing sleep"
			if caller:
				os.dup2(stdout_w, sys.stdout.fileno())
				os.dup2(stdin_r, sys.stdin.fileno())
			try: os.execv(path,params)
			except: print "hmm dying"; time.sleep(1); os._exit(1)

		else:
			if caller:
				caller.stdin_w=stdin_w
				caller.stdout_r=stdout_r
			#print "parent, child id is ",a
			return a
	else:
		print "file do not exists: ",path
		return 0

class FileManage:
	def __init__(self,boxptr=0,win=0):
		# ignore sigchild so we do not get zombies
	        signal.signal(signal.SIGCHLD, signal.SIG_IGN)
		# window
		if boxptr==0:
			self.w=GtkWindow()
			self.w.connect('destroy',mainquit)
			self.w.set_usize(240, 310)
			#self.w.set_uposition(1,-1)
			#self.w.set_policy(FALSE,FALSE,FALSE)

			#hbox
			#self.b=GtkHBox()
			self.b=GtkHPaned()
			self.w.add(self.b)
		else:
			self.b=GtkHPaned()
			boxptr.pack_start(self.b)
			self.w=win

		self.load_config()
		#tree
		self.sw = GtkScrolledWindow()
		self.sw.set_policy(POLICY_AUTOMATIC, POLICY_AUTOMATIC)
		#self.b.pack_start(self.sw)
		self.b.add1(self.sw)
		if self.get_conf("show dirtree",0):
			self.sw.set_usize(80,280)
			self.sw.show()
		self.root=GtkTree("")
		self.sw.add_with_viewport(self.root)
		self.root.show()

		#leafpath="/home/erez/ipaq-linux"
		self.view_disabled=0;
		leafpath="/"
		self.leaf=GtkTreeItem(leafpath)
		self.path="/"
		self.tree=ALeaf(self.leaf,leafpath,self)
		self.root.append(self.leaf)
		self.leaf.show()

		#leaf.set_subtree(self.SubLeaf(leafpath))

		#leaf.set_subtree(self.tree)
		#self.list.set_selection_mode(SELECTION_MULTIPLE)
		#self.list.set_selection_mode(SELECTION_BROWSE)
		#self.b.pack_start(leaf)
		#self.listitem=GtkListItem("Root")
		#self.list.add(self.listitem)
		#self.listitem.show()
		#seperator
		##self.s1=GtkVSeparator()
		##self.b.pack_start(self.s1)
		##self.s1.show()

		#b2
		self.b2=GtkVBox()
		#self.b.pack_start(self.b2)
		self.b.add2(self.b2)
		self.b2.show()
		#pathbar
		self.pathbarOptionMenu=GtkOptionMenu()
		self.b2.pack_start(self.pathbarOptionMenu)
		self.pathbarOptionMenu.show()
		self.pathbar=0
		#sw2
		self.sw2 = GtkScrolledWindow()
		self.sw2.set_policy(POLICY_AUTOMATIC, POLICY_AUTOMATIC)
		self.b2.pack_start(self.sw2)
		self.sw2.set_usize(100,240)
		self.sw2.show()
		#clist
		self.clist=GtkCList(3,["Name","Size","Type"])
		self.clist.set_column_width(0, 80)
		self.clist.set_column_width(1, 30)
		self.clist.set_column_width(2, 30)
		self.sw2.add_with_viewport(self.clist)
		self.clist.show()
		self.clist.connect("select_row",self.clist_selected)
		# b4
		self.b4=GtkHBox()
		self.b2.pack_start(self.b4,0)
		self.b4.show()
		#buttons in b4
		self.pid=-1
		self.bt21=GtkButton(label="Rec")
		self.b4.pack_start(self.bt21)
		self.bt21.show()
		self.bt21.connect('clicked',self.recbutton)
		self.bt22=GtkButton(label="Kill")
		self.b4.pack_start(self.bt22)
		self.bt22.show()
		self.bt22.connect('clicked',self.killbutton)
		self.bt23=GtkButton(label="Beam")
		self.b4.pack_start(self.bt23)
		self.bt23.show()
		self.beaming=0
		self.bt23.connect('clicked',self.beambutton)
		self.bt24=GtkButton(label="Config")
		self.b4.pack_start(self.bt24)
		self.bt24.show()
		self.config_window=0
		self.bt24.connect('clicked',self.configbutton)
		# b3
		self.b3=GtkHBox()
		self.b2.pack_start(self.b3,0)
		self.b3.show()
		#buttons in b3
		self.dialogs={}
		self.cut=0
		self.copy=0
		self.bt1=GtkButton(label="Open")
		self.b3.pack_start(self.bt1)
		self.bt1.show()
		self.bt1.connect('clicked',self.execbutton)
		self.bt2=GtkButton(label="Delete")
		self.b3.pack_start(self.bt2)
		self.bt2.show()
		self.bt2.connect('clicked',self.deletebutton)
		self.bt3=GtkButton(label="Cut")
		self.b3.pack_start(self.bt3)
		self.bt3.show()
		self.bt3.connect('clicked',self.cutbutton)
		self.bt4=GtkButton(label="Copy")
		self.b3.pack_start(self.bt4)
		self.bt4.show()
		self.bt4.connect('clicked',self.copybutton)
		self.bt5=GtkButton(label="Paste")
		self.b3.pack_start(self.bt5)
		self.bt5.show()
		self.bt5.connect('clicked',self.pastebutton)
		#programs
		self.leaf_goto(os.path.expanduser("~"))
		#show
		self.b.show()
		if boxptr==0: self.w.show()
		#idle
		self.first_idle=1
		idle_add(self.idle)

	def load_config(self):
		self.ConfigFileName=os.path.expanduser(ConfigFileName)
		if os.path.exists(self.ConfigFileName):
			print "config file found\n"
			f=open(self.ConfigFileName,"r")
			self.config=eval(f.read())
			f.close()
		else:
			self.config={}
		# set default values:
		self.get_conf("programs",{
					'mp3': ['/usr/bin/madplay'],
					'txt': ['/usr/X11R6/bin/rxvt', '-e', '/usr/bin/less'],
					'z80': ['/root/bin/xspect', '-no-sound'],
					'avi': ['/usr/local/bin/xine'],
					'dsp': ['/bin/dd', 'if=<>', 'of=/dev/dsp'],
					'gif': ['/usr/X11R6/bin/qiv', '-t'],
					'jpg': ['/usr/X11R6/bin/qiv', '-t'],
					'py': ['/usr/bin/python'],
					'html': ['/usr/bin/dillo'],
					'tgz': ['/usr/X11R6/bin/rxvt', '-e', '/bin/sh', '-c', '/bin/tar tzvf <> | /usr/bin/less'],
					'sna': ['/root/bin/xspect', '-no-sound'],
					'tap': ['/root/bin/xspect', '-no-sound'],
					'txt.gz': ['/usr/X11R6/bin/rxvt', '-e', '/bin/sh', '-c', '/bin/gzip -dc <> | /usr/bin/less'],
					'xmodmap': ['/usr/X11R6/bin/xmodmap'],
					'mpg': ['/root/bin/mpeg_play']
				})
		self.get_conf("irobex",1)
		self.get_conf("show dirtree",1)
		# resr of the parameters default to 0
		for a in Params:
			if not self.config.has_key(a):
				self.config[a]=0

	def get_conf(self,key,default):
		if self.config.has_key(key):
			return self.config[key]
		else:
			self.config[key]=default
			return default

	def configbutton(self,e):
		if not self.config_window:
			self.config_window=GtkWindow()
			self.config_window.connect('destroy',self.configbutton_destroy)
			self.config_box1=GtkVBox()
			self.config_window.add(self.config_box1)
			self.config_l1=GtkLabel("Options:")
			self.config_l1.show()
			self.config_box1.pack_start(self.config_l1)
			self.config_option={}
			for a in Params:
				self.config_option[a]=GtkCheckButton(a)
				self.config_box1.pack_start(self.config_option[a])
				self.config_option[a].show()
			self.config_s1=GtkHSeparator()
			self.config_box1.pack_start(self.config_s1)
			self.config_s1.show()
			self.config_l2=GtkLabel("External apps:")
			self.config_l2.show()
			self.config_box1.pack_start(self.config_l2)
			self.config_prog={}
			for a in self.get_conf("programs",{}).keys():
				self.config_prog[a]=GtkLabel("%s:%s"%(a,self.get_conf("programs",{})[a]))
				self.config_box1.pack_start(self.config_prog[a])
				self.config_prog[a].show()
			self.config_s2=GtkHSeparator()
			self.config_box1.pack_start(self.config_s2)
			self.config_s2.show()
			self.config_box2=GtkHBox()
			self.config_box1.pack_start(self.config_box2)
			self.config_bt1=GtkButton("Cancel")
			self.config_bt1.show()
			self.config_bt1.connect('clicked',self.configbutton_cancel)
			self.config_box2.pack_start(self.config_bt1)
			self.config_bt2=GtkButton("Save")
			self.config_bt2.show()
			self.config_bt2.connect('clicked',self.configbutton_save)
			self.config_box2.pack_start(self.config_bt2)
			self.config_box2.show()
			self.config_box1.show()
		for a in Params:
			self.config_option[a].set_active(self.get_conf(a,0))
		self.config_window.show()
			
	def configbutton_save(self,e):
		if self.config["show dirtree"]!=self.config_option["show dirtree"].get_active():
			if self.config["show dirtree"]==0:
				self.sw.set_usize(80,260)
				self.sw.show()
			else:
				self.sw.set_usize(0,0)
				self.sw.hide()
				
		for a in Params:
			self.config[a]=self.config_option[a].get_active()
		try:
			f=open(self.ConfigFileName,"w")
			f.write("%s"%self.config)
			f.close()
		except:
			print "Could not write to config file '"+self.ConfigFileName+"'\n"
		self.config_window.hide()

	def configbutton_cancel(self,e):
		self.config_window.hide()

	def configbutton_destroy(self,e):
		self.config_window.hide()
		self.config_window=0

	def receive_ir(self,start):
		if start:
			if not self.infra_window:
				self.infra_window=GtkWindow()
				self.infra_box=GtkVBox()
				self.infra_window.add(self.infra_box)
				self.infra_box.show()
				self.infra_peer_l=GtkLabel("")
				self.infra_box.pack_start(self.infra_peer_l)
				self.infra_status_l=GtkLabel("")
				self.infra_box.pack_start(self.infra_status_l)
				self.infra_peer_l.show()
				self.infra_status_l.show()
			self.infra_window.show()
		else:
			self.infra_window.hide()

	def idle(self):
		if self.first_idle:
			self.irobex_pid=0
			self.remote_name=""
			self.infra_window=0
			self.secnow=0
			if no_fcntl==0 and self.get_conf("irobex",1):
				os.system("hostname > /proc/sys/net/irda/devname")
		self.timenow=time.localtime(time.time())
		time.sleep(0.01)
		if self.irobex_pid and no_fcntl==0 and self.get_conf("irobex",1):
			#if os.path.exists("/proc/%d" % self.irobex_pid):
			try:a=os.read(self.stdout_r,100)
			except: a=0
			if a!=0:
				self.irobex_output=self.irobex_output+a
			print self.irobex_output,"a=",a
		if self.timenow[5]!=self.secnow or self.first_idle:
			self.first_idle=0
			self.secnow=self.timenow[5]
			# gets here about every second

			if no_fcntl==0 and self.get_conf("irobex",1):
				# open new window for receive infra when new peer
				if os.path.exists("/proc/net/irda/discovery"):
					f=open("/proc/net/irda/discovery","r")
					l=f.readline()
					l=f.readline()
					l=f.readline()
					f.close()
					pos=string.find(l,'nickname: ')
					if pos>=0:
						pos=string.find(l,', hint:')
						l=l[10:pos]
						if l!=self.remote_name:
							#or not os.path.exists("/proc/%d" % self.irobex_pid):
							self.receive_ir(1)
							self.irobex_output=""
							print "New Peer:",l
							self.infra_peer_l.set_text("Remote: "+l)
							self.remote_name=l
							if self.beaming:
								self.irobex_pid=spawn("/usr/bin/irobex_palm3",["irobex_palm3",self.beampath],self)
							else:
								self.irobex_pid=spawn("/usr/bin/irobex_palm3",["irobex_palm3"],self)
							#fcntl.fcntl(self.stdout_r,FCNTL.F_SETFL, FCNTL.O_NONBLOCK)
							fcntl.fcntl(self.stdout_r,4, os.O_NONBLOCK)
							os.system("echo 1 > /proc/sys/net/irda/discovery")
	
	
						if self.irobex_output[-1:]==".":
							if self.beaming:
								self.infra_status_l.set_text("Sending")
							else:
								self.infra_status_l.set_text("Receiving")
						else:
							if self.beaming:
								pos=string.find(self.irobex_output,"\nPUT ")
							else:
								pos=string.find(self.irobex_output,"\nWrote")
							if pos<0:
								self.infra_status_l.set_text("")
							else:
								self.infra_status_l.set_text(self.irobex_output[pos:])
								#os.system("echo 0 > /proc/sys/net/irda/discovery")
					else:
						if self.beaming:
							self.beaming=self.beaming-1
							if self.beaming==1:
								os.system("echo 0 > /proc/sys/net/irda/discovery")
	
						if self.remote_name!="":
							print "Peer Lost!"
							self.infra_peer_l.set_text("No remote peer found")
							self.remote_name=""
							try: os.kill(self.irobex_pid,15)
							except: print "irobex_palm3 already dead"
							os.system("echo 0 > /proc/sys/net/irda/discovery")
							self.irobex_pid=0
							self.beaming=0
							self.receive_ir(0)
		return 1

		
	def pastebutton(self,item):
		if self.cut==0 and self.copy==0:
			print "no file to paste"
			return
		if self.cutpath+self.cutname==self.path+self.cutname and self.cut:
			print "Destination and Source files are the same"
			return
		name=self.cutname
		while os.path.isfile(self.path+name):
			#a=self.ask("Overwrite %s ?"%(self.path+name))
			#if a=="c": return
			#if a=="y":
			#	os.remove(self.path+name)
			#else:
			#	name="Another "+name
			name="Another "+name
		if self.cut:
			os.system("/bin/mv '"+self.cutpath+self.cutname+"' '"+self.path+name+"'")
			print "/bin/mv '"+self.cutpath+self.cutname+"' '"+self.path+name+"'"
		else:
			os.system("/bin/cp -p '"+self.cutpath+self.cutname+"' '"+self.path+name+"'")
			print "/bin/cp -p '"+self.cutpath+self.cutname+"' '"+self.path+name+"'"
		self.view(self.path)
		self.cut=0
			
	def deletebutton(self,item):
		p=self.path+self.clist.get_text(self.selected_clist,0)
		self.path2delete=p
		if not self.dialogs.has_key("delete"):
			a=GtkDialog()
			self.deletebutton_yes=GtkButton("Yes")
			self.deletebutton_yes.connect("clicked",self.deletebutton_confirmed)
			a.action_area.pack_start(self.deletebutton_yes)
			self.deletebutton_yes.show()
			self.deletebutton_no=GtkButton("No")
			self.deletebutton_no.connect("clicked",a.hide)
			a.action_area.pack_start(self.deletebutton_no)
			self.deletebutton_no.show()
			self.deletebutton_text=GtkLabel("")
			self.deletebutton_text.show()
			a.vbox.pack_start(self.deletebutton_text)
		else:
			a=self.dialogs["delete"]
		a.set_title("Delete '%s', Are You Sure ?"%p)
		self.deletebutton_text.set_text("Delete '%s', Are You Sure ?"%p)
		a.show()
		self.dialogs["delete"]=a
	def deletebutton_confirmed(self,item):
		print "delete '"+self.path2delete+"'"
		os.system("/bin/rm -f '"+self.path2delete+"'")
		self.dialogs["delete"].hide()
		self.view(self.path)

	def copybutton(self,item):
		print "copy "+self.path+self.clist.get_text(self.selected_clist,0)
		self.cutpath=self.path
		self.cutname=self.clist.get_text(self.selected_clist,0)
		self.cut=0
		self.copy=1

	def cutbutton(self,item):
		print "cut "+self.path+self.clist.get_text(self.selected_clist,0)
		self.cutpath=self.path
		self.cutname=self.clist.get_text(self.selected_clist,0)
		self.cut=1
		self.copy=0

	def recbutton(self,item):
		i=0
		p=self.path
		p="/tmp/"
		while (0!=os.path.exists(p+("rec%d"%i)+".dsp")):
			i=i+1
		name=p+("rec%d"%i)+".dsp"
		self.pid=spawn("/bin/dd",["/bin/dd","of=%s"%name,"if=/dev/dsp" ])

	def beambutton(self,item):
		self.beaming=5 # beam only if discover peer in 5 seconds
		os.system("ifconfig irda0 up;hostname > /proc/sys/net/irda/devname; echo 1 > /proc/sys/net/irda/discovery")
		self.beampath=self.path+"/"+self.clist.get_text(self.selected_clist,0)
		# from hear on, it will be handled by idle()

	def killbutton(self,item):
		if self.pid==-1: return
		try: os.kill(self.pid,15)
		except: print "Cant kill pid ",`self.pid`
		self.pid=-1
		self.view(self.path)

	def execbutton(self,item):
		#print "Ouch, self=",self," item=",item
		name=self.clist.get_text(self.selected_clist,0)
		if os.path.isdir(self.path+name):
			if name=="..":
				print self.path
				if self.path[-1:]=="/":
					self.path=self.path[:-1]
				print self.path
				p=string.rfind(self.path,"/")
				print p
				if p<0:
					self.path="/"
				else:
					self.path=self.path[:p]
				name=""
				print self.path
			self.leaf_goto(self.path+name)
			return
		k=self.get_conf("programs",{}).keys()
		e=self.clist.get_text(self.selected_clist,2)
		for i in k:
			if string.upper(e)==string.upper(i):
				a=[]
				c=0
				for b in range(0,len(self.get_conf("programs",{})[i])):
					#if self.get_conf("programs",{})[i][b]=="<>":
					q=self.get_conf("programs",{})[i][b]
					pos=string.find(q,"<>")
					if pos>=0:
						q=q[:pos]+self.path+name+q[pos+2:]
						c=1
					a=a+[q]
				if c==0: a=a+[self.path+name]
				cwd=os.getcwd()
				os.chdir(self.path)
				self.pid=spawn(self.get_conf("programs",{})[i][0],a)
				os.chdir(cwd)
				#self.pid=spawn(self.get_conf("programs",{})[i][0],
					#self.get_conf("programs",{})[i]+[self.path+name])
					#[self.get_conf("programs",{})[i],self.path+name])

				return
		if os.access(self.path+name,os.X_OK):
			cwd=os.getcwd()
			os.chdir(self.path)
			#print "fixme: execute "+self.path+name
			#self.pid=spawn(self.path+name,[name])
			self.pid=spawn("/bin/sh",["sh","-c",self.path+name])
			os.chdir(cwd)
		else:
			print self.path+name+" can't be executed"


			
		

	def clist_selected(self,clist,r,c,ev):
		self.selected_clist=r

	def ouch(self,item):
		print "Ouch, self=",self," item=",item

	def set_pathbar(self,path):
		if self.pathbar:
			self.pathbar.destroy()
		self.pathbar=GtkMenu()
		b=""
		for a in string.split(path,"/"):
			if a!="" or b!="":
				c=final_menu_item(b,self.leaf_goto)
				self.pathbar.prepend(c.menuitem)
			if b[-1:]!="/":
				b=b+"/"
			b=b+a
		self.pathbarOptionMenu.set_menu(self.pathbar)
		self.pathbar.show()


	def view(self,path):
		if self.view_disabled: return
		if path[-1:]!="/": path=path+"/"
		self.clist.clear()
		self.path=path
		self.set_pathbar(path)
		for f in [".."]+os.listdir(path):
			if os.path.isfile(path+f)  or (self.get_conf("show dirs",0) and (f==".." or os.path.isdir(path+f))):
				if f[0]!="." or self.get_conf("show dotfiles",0) or f=="..":
					pos=string.find(f,".")
					if (pos<0): ext=""
					else: ext=f[pos+1:]
					if f==".." or os.path.isdir(path+f):
						ext="DIR"
					#pos=len(f)-1
					#ext=string.split(f,".")
					#ext=ext[len(ext)-1]
					#ext=""
					#while (f[pos]!="." and pos>0): pos=pos-1
					#if f[pos]==".": ext=f[pos+1:]
					a=[f,"%d"%os.path.getsize(path+f),ext]
					self.clist.append(a)
		self.clist.thaw()
	def ask(self,question):
		a=Ask(question)
		while a.answer==0:
			time.sleep(0.01)
		b=a.answer
		a.destroy()
		return b

	def leaf_goto(self,path):
		self.view_disabled=1
		a=self.tree
		self.leaf.select()
		self.leaf.expand()
		self.leaf.deselect()
		for name in string.split(path,"/"):
		   if name!="":
		   	print name
			a.exp1("")
			if not a.subtree.items.has_key(name):
				print "did not find key",name
				return
			#if a!=self.tree:
			#	_gtk.gtk_signal_emitv_by_name(a.subtree.tree._o,"expand",[])
			a=a.subtree.items[name]
			a.ti.select()
			a.ti.expand()
			a.ti.deselect()
			#a.exp1("")
			#print name
			#a.ti.signal_emit("expand")
			#_gtk.gtk_signal_emitv_by_name(a.ti._o,"expand",[])
		a.ti.collapse()
		a.ti.select()
		self.view_disabled=0
		self.view(path)

		
class ALeaf:
	def __init__(self,c,path,fm):
		self.path=path
		self.fm=fm
		self.exposed=0
		self.c=c
		c.connect('expand',self.expall)
		c.connect('select',self.exp1)

	def sel(self,e):
		print "sel:",self.path

	def expall(self,e):
		self.exp1("")
		#print "expanding items %s ..."%self.subtree.items
		return
		for i in self.subtree.items.keys():
			print "expanding "+i+":"
			self.subtree.items[i].exp1("")

	def exp1(self,e):
		#print "exp1:",self.path
		if not self.exposed:
			self.exposed=1
			#name=string.split(self.path,"/")
			#name=name[len(name)-1]
			#if name=="": name="/"
			#print "name="+name
			self.subtree=SubLeaf(self.path,self.fm)
			if self.subtree.tree!=0:
				self.c.set_subtree(self.subtree.tree)
			#self.c.set_subtree( self.fm.SubLeaf(self.path))
		self.fm.view(self.path)


class Ask:
	def __init__(self,question):
		self.answer=0
		w=GtkDialog()
		#w.connect("delete_event", delete_event)
		w.set_title(question)
		b1 = GtkButton("Yes")
		b1.connect("clicked", self.yep)
		w.action_area.pack_start(b1)
		b1.show()
		b2 = GtkButton("No")
		b2.connect("clicked", self.no)
		w.action_area.pack_start(b2)
		b2.show()
		b3 = GtkButton("Cancel")
		b3.connect("clicked", self.cancel)
		w.action_area.pack_start(b3)
		b3.show()
		w.show()

	def yep(self,e):
		self.answer="y"

	def no(self,e):
		self.answer="n"

	def cancel(self,e):
		self.answer="c"
		
class SubLeaf:
	def __init__(self,path,fm):
		#GtkTree();
		self.items={}
		#self.tree=GtkTree();
		self.tree=0
		if path[-1:]!="/": path=path+"/"
		for b in os.listdir(path):
			#print "isdir(%s)"%(path+b+"/.")
			#if os.path.isdir(path+b+"/."):
			if os.path.isdir(path+b):
				if b[0]!="." or fm.get_conf("show dotdirs",0):
					ti=GtkTreeItem(b)
					self.items[b]=ALeaf(ti,path+b,fm)
					#ALeaf(ti,path+b,self)
					if self.tree==0:
						self.tree=GtkTree()
					self.tree.append(ti);
					ti.show()
					self.items[b].ti=ti
					#c.set_subtree(self.SubLeaf(path+b))
		#return self;

class final_menu_item:
        def __init__(self,label,onclick):
                self.menuitem=GtkMenuItem(label)
                self.label=label
                self.menuitem.connect("activate",self.activated)
		self.onclick=onclick
		self.menuitem.show()

        def activated(self,ev):
		self.onclick(self.label)
                #print "Executing:",self.command
                #spawn("/bin/sh" , [ "/bin/sh","-c",self.command])
		


if(__name__=="__main__"):
	app=FileManage()
	mainloop()

